
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>hdu 1711 Number Sequence  解题报告 / 憋错料</title>

    <meta name="description" content="hdu 1711 Number Sequence  解题报告 题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1711 题目意思:给出一条有n个数的序列a[1],a[2],......,a[n],和一条有m 个数的序列b[1],b[2],......,b[m],求出b[1],b[2],...,b[m]在序列a中完全匹配时,在序列a中的位置,如果找不到输出-1. 这几天一直在学kmp,该题算是kmp的入门题吧.有个地方要稍稍注意,代码中,主串和模式串的比较初始值为-1,-1,否则如果从0开始,会默认第一个字符是相">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">hdu 1711 Number Sequence  解题报告</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><P>题目链接：<A href="http://acm.hdu.edu.cn/showproblem.php?pid=1711" rel="external nofollow noreferrer">http://acm.hdu.edu.cn/showproblem.php?pid=1711</A></p>
<p>题目意思：给出一条有n个数的序列a[1]，a[2]，......，a[n]，和一条有m<br />
个数的序列b[1]，b[2]，......，b[m]，求出b[1]，b[2]，...，b[m]在序列a中完全匹配时，在序列a中的位置，如果找不到输出-1.</p>
<p>这几天一直在学kmp，该题算是kmp的入门题吧。有个地方要稍稍注意，代码中，主串和模式串的比较初始值为-1，-1，否则如果从0开始，会默认第一个字符是相等的！！！</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"><br /><PRE> 1 #include &lt;iostream&gt;<br />
 2 #include &lt;cstdlib&gt;<br />
 3 #include &lt;cstdio&gt;<br />
 4 using namespace std;<br />
 5<br />
 6 const int N = 1e6 + 5;<br />
 7 const int M = 1e4 + 5;<br />
 8 int next[M], n, m;<br />
 9 int a[N], b[M];<br />
10<br />
11 void get_next(int *next)<br />
12 {<br />
13     int i = 0;<br />
14     int j = -1;<br />
15     next[0] = -1;<br />
16     while (i &lt; m)<br />
17     {<br />
18         if (j == -1 || b[i] == b[j])<br />
19         {<br />
20             i++;<br />
21             j++;<br />
22             next[i] = j;<br />
23         }<br />
24         else<br />
25             j = next[j];<br />
26     }<br />
27 }<br />
28<br />
29 int main()<br />
30 {<br />
31     int T, i, j;<br />
32     while (scanf("%d", &amp;T) != EOF)<br />
33     {<br />
34         while (T--)<br />
35         {<br />
36             scanf("%d%d", &amp;n, &amp;m);<br />
37             for (i = 0; i &lt; n; i++)<br />
38                 scanf("%d", &amp;a[i]);<br />
39             for (i = 0; i &lt; m; i++)<br />
40                 scanf("%d", &amp;b[i]);<br />
41             get_next(next);<br />
42             i = -1, j = -1;<br />
43             int ans = -1;<br />
44             while (i &lt;= n &amp;&amp; j &lt;= m)<br />
45             {<br />
46                 if (j == -1 || a[i] == b[j])    // 关键！<br />
47                 {<br />
48                     ++i;<br />
49                     ++j;<br />
50                 }<br />
51                 else<br />
52                     j = next[j];<br />
53                 if (j == m)<br />
54                 {<br />
55                    ans = i - m + 1;<br />
56                    break;<br />
57                 }<br />
58             }<br />
59             printf("%d\n", ans);<br />
60         }<br />
61     }<br />
62     return 0;<br />
63 }</PRE></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<p><P>hdu 1711 Number Sequence  解题报告</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-28 21:37:05 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/style/" title="style">style</a>, <a href="https://www.biecuoliao.com/tag/java/" title="java">java</a>, <a href="https://www.biecuoliao.com/tag/code/" title="code">code</a>, <a href="https://www.biecuoliao.com/tag/ext/" title="ext">ext</a>, <a href="https://www.biecuoliao.com/tag/class/" title="class">class</a>, <a href="https://www.biecuoliao.com/tag/blog/" title="blog">blog</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>hdu 1711 Number Sequence  解题报告的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0jyBjeM.html" rel="bookmark">KMP算法的定义及KMP练手题  HDU 1711 Number Sequence  （我的模板代码）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题意:就是要你来找出b数组在a数组中最先匹配的位置,如果没有则输出-1 思路:直接KMP算法(算法具体思想这位牛写的不错http://blog.csdn.net/v_july_v/article/details/7041827) AC代码: #include&lt;cstdio&gt; #include&lt;cstring&gt; #include&lt;stdlib.h&gt; #include&lt;iostream&gt; using namespace std; #define maxn 100			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0bYDjYM.html" rel="bookmark">hdu 1711 Number Sequence&lpar;KMP&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				# include &lt;stdio.h&gt; # include &lt;string.h&gt; # include &lt;algorithm&gt; using namespace std; int n,m,next[10010],a[1000010],b[10010]; void Getnext() { int i=0,j=-1; next[0]=-1; while(i&lt;m) { if(j==-1||b[i]==b[j]) i++,j++,next[i]=j; else j=next[			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qQ2LD3.html" rel="bookmark">HDU 1711 Number Sequence KMP题解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				KMP查找整数数列,不是查找字符串. 原理是一样的,不过把字符串转换为数列,其他基本上是一样的. #include &lt;stdio.h&gt; #include &lt;string.h&gt; const int MAX_N = 1000001; const int MAX_M = 10001; int strN[MAX_N], strM[MAX_M], next[MAX_M], N, M; void getNext() { memset(next, 0, sizeof(int) * M); for			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0RG5kR3.html" rel="bookmark">HDU - 1711 Number Sequence KMP字符串匹配</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				HDU - 1711 Number Sequence Time Limit: 5000MS   Memory Limit: 32768KB   64bit IO Format: %I64d &amp; %I64u Submit Status Description Given two sequences of numbers : a[1], a[2], ...... , a[N], and b[1], b[2], ...... , b[M] (1 &lt;= M &lt;= 10000, 1 &lt;=			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0ex5RbM.html" rel="bookmark">HDU 1711 Number Sequence&lpar;字符串匹配&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Number Sequence Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 10571    Accepted Submission(s): 4814 Problem Description Given two sequences of numbers : a[1], a[2], ...... , a[N], and b[1],			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vbL5o3.html" rel="bookmark">HDU 1711 Number Sequence 【KMP应用 求成功匹配子串的最小下标】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				传送门:http://acm.hdu.edu.cn/showproblem.php?pid=1711 Number Sequence Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 42917    Accepted Submission(s): 17715 Problem Description Given two sequences			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0lX1rL0.html" rel="bookmark">HDU 1711 Number Sequence&lpar;KMP算法&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1711 Number Sequence Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 15548    Accepted Submission(s): 6836 Problem Description Given two sequence			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgQO5n3.html" rel="bookmark">hdu 1711 Number Sequence  KMP 基础题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Number Sequence Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 11691    Accepted Submission(s): 5336 Problem Description Given two sequences of numbers : a[1], a[2], ...... , a[N], and b[1],			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pGbxy3.html" rel="bookmark">HDU 1711  Number Sequence   &lpar;简单KMP&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				#include &lt;stdio.h&gt; #include &lt;string.h&gt; int next[10005]; int str1[1000005],str2[10005]; void build_next(int len2) { int i=0,j=-1; next[0] = -1; while (i &lt; len2) { if (j==-1 || str2[i] == str2[j]) { i++; j++; if (str2[i] != str2[j]) { next[i]			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmGOlP3.html" rel="bookmark" class="title">掌握需求过程（一）</a>
					<div>
						需求过程把重点放在提交的产物上,我们需要得到这些产物,从而建立可测试和可跟踪的需求规格说明书.这些提交的产物为管理项目提供了早期的衡量标准.我们可以对收集.提取.编写和检查需求的过程进行剪裁,以便让这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02bGxp0.html" rel="bookmark" class="title">为什么会有堆内存和栈内存之分</a>
					<div>
						当一个方法执行时,每个方法都会建立自己的内存栈,在这个方法内定义的变量将会逐个放入这块栈内存里,随着方法的执行结束,逐个方法的内存栈也将自然销毁.因此,所有的在方法中定义的局部变量都是放在栈内存中的. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEkdvg3.html" rel="bookmark" class="title">&lbrack;Linux&rsqb;&lbrack;Nginx&rsqb;Install</a>
					<div>
						# 安装必要的组件 yum install -y gcc pcre* openssl-devel # 创建组和用户 groupadd nginx useradd -g nginx nginx -s / ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/My51PaM.html" rel="bookmark" class="title">针对各组项目的改进意见</a>
					<div>
						第一组: 项目:微食堂. 页面比较美观,完成程度较高,页面布局十分不错,注册页面与登录界面布局完善,信息部分需要完善,图片麻烦能不能取真实的,这不是欺骗消费者么,希望能够改善这方面,我还挺看重这个的, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz8mAA3.html" rel="bookmark" class="title">iOS9 UIWindow rootViewController</a>
					<div>
						在iOS9中App被其他应用唤起的时候Crash,正常启动或者调试模式都不会Crash. 通过XCode - Window -Device,查看设备的log,如下 Assertion failure  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02mGynM.html" rel="bookmark" class="title">java中post和get请求</a>
					<div>
						示例代码: package com.shareboxes.util; import java.io.BufferedReader; import java.io.IOException; import ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Myjdpm0.html" rel="bookmark" class="title">Oracle&colon;ORA-24324&colon; 未初始化服务句柄  ORA-01090&colon; 正在关闭 - 不允许连接</a>
					<div>
						1.sqlplus/nolog 2.SQL&gt; conn / as sysdba已连接到空闲例程.3.SQL&gt; shutdown abortORACLE 例程已经关闭.4.SQL&gt; s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4ARDbKM.html" rel="bookmark" class="title">Tomcat下为每个Web应用配置不同的访问端口</a>
					<div>
						在server.xml中配置两个service为Catalina.app1和Catalina.app2  &lt;Service name=&quot;Catalina.app1&quot;&gt;  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RD8LP4.html" rel="bookmark" class="title">&lbrack;NOIP2014普及组&rsqb;比例简化</a>
					<div>
						题目地址: ayyzvijos:http://pingce.ayyz.cn/vijos/Problem_Show.asp?id=2016 vijos:https://vijos.org/p/1912  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyWQBn3.html" rel="bookmark" class="title">网络编程-TCP程序实例（简单上传图片）</a>
					<div>
						package netTest; /* * 客户端: * 1.服务端点 * 2.读取客户端已有的图片数据 * 3.通过socket输出流将数据发给服务端 * 4.读取服务端的反馈信息 * 5.关闭.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49WRVn0.html" rel="bookmark" class="title">MVC4 WebAPI POST数据问题</a>
					<div>
						api [HttpPost] public string PostAvartos(Test model) { if (model != null) { LoggerHelper.WriteInfo(m ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDyPB90.html" rel="bookmark" class="title">javascript中12种DOM节点类型概述</a>
					<div>
						× 目录 [1]元素 [2]特性 [3]文本[4]CDATA[5]实体引用[6]实体名称[7]处理指令[8]注释[9]文档[10]文档类型[11]文档片段[12]DTD 前面的话 DOM是javasc ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6zRZyM.html" rel="bookmark" class="title">数据库事务的四大特性和隔离级别</a>
					<div>
						数据库事务(Database Transaction) ,是指作为单个逻辑工作单元执行的一系列操作,要么全部执行,要么全部都不执行. 一个逻辑工作单元要成为事务,必须满足事务的四大特性(ACID).即 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mgld9L0.html" rel="bookmark" class="title">Android官方开发文档Training系列课程中文版：手势处理之记录手指移动的轨迹</a>
					<div>
						原文地址:http://android.xsoftlab.net/training/gestures/movement.html 这节课将会学习如何在触摸事件中记录手指移动的轨迹. 当手指触摸的位置. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyQmDAM.html" rel="bookmark" class="title">苹果API常用英语名词</a>
					<div>
						1 0. indicating 决定 2 1.in order to 以便 3 2.rectangle bounds 矩形尺寸 4 3.applied 应用 5 4.entirety 全部 6 5.t ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49ePag4.html" rel="bookmark" class="title">mysql设计规范一</a>
					<div>
						原文地址:http://www.jianshu.com/p/33b7b6e0a396 主键 表中每一行都应该有可以唯一标识自己的一列(或一组列). 一个顾客可以使用顾客编号列,而订单可以使用订单ID, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NymZw3.html" rel="bookmark" class="title">LeetCode &num;4 （A nice explanation from MissMary）</a>
					<div>
						Given a sorted array A with length m, we can split it into two part: { A[0], A[1], ... , A[i - 1] }  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pN7Kx0.html" rel="bookmark" class="title">ActionBar基础学习之头部返回菜单</a>
					<div>
						在开写之前需要先引入工程包lib_v7_appcompat,里面为我们提供了ActionBarActivity等许多相关类. 先新建一个activity来继承ActionBarActivity,在里面 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l1RmX3.html" rel="bookmark" class="title">设计模式学习笔记--备忘录&lpar;Mamento&rpar;模式</a>
					<div>
						写在模式学习之前 什么是设计模式:在我们进行程序设计时,逐渐形成了一些典型问题和问题的解决方案,这就是软件模式:每一个模式描述了一个在我们程序设计中经常发生的问题,以及该问题的解决方案:当我们碰到模式 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38y5Yn4.html" rel="bookmark" class="title">CentOS上部署Django</a>
					<div>
						第一步:安装python3 wget https://www.python.org/ftp/python/3.6.1/Python-3.6.1.tar.xz 解压配置安装 tar xvzf Pytho ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
